(use numbers test grobner-basis)

(define S 1)
(define G 1)
(define RG 1)
(define GB 1)


;; inconsistent system
(set! S (list '((4 0 0 0)) '((3 0 0 0)) '((2 0 0 0)) ))
(test (polys-string lex-rational-xyz S) '"[(4),(3),(2)]")
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB) '"[(1)]")
(test (polys-string lex-rational-xyz S) '"[(4),(3),(2)]")



;; gcd <> 0
(set! S (list
  '((29 10 6 2)(29 10 6 4)(29 10 8 2)(29 10 8 4)(29 12 6 2)(29 12 6 4)(29 12 8 2)(29 12 8 4))
  '((30 10 6 2)(30 10 6 4)(30 10 8 2)(30 10 8 4)(30 12 6 2)(30 12 6 4)(30 12 8 2)(30 12 8 4)) ))
(test (polys-string lex-rational-xyz S) 
	'"[(29*x^10*y^6*z^2)+(29*x^10*y^6*z^4)+(29*x^10*y^8*z^2)+(29*x^10*y^8*z^4)+(29*x^12*y^6*z^2)+(29*x^12*y^6*z^4)+(29*x^12*y^8*z^2)+(29*x^12*y^8*z^4),(30*x^10*y^6*z^2)+(30*x^10*y^6*z^4)+(30*x^10*y^8*z^2)+(30*x^10*y^8*z^4)+(30*x^12*y^6*z^2)+(30*x^12*y^6*z^4)+(30*x^12*y^8*z^2)+(30*x^12*y^8*z^4)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(x^12*y^8*z^4)+(x^12*y^8*z^2)+(x^12*y^6*z^4)+(x^12*y^6*z^2)+(x^10*y^8*z^4)+(x^10*y^8*z^2)+(x^10*y^6*z^4)+(x^10*y^6*z^2)]"
)


;; duplicate polynomials
(set! S (list
  '((29 10 6 2)(29 10 6 4)(29 10 8 2)(29 10 8 4)(29 12 6 2)(29 12 6 4)(29 12 8 2)(29 12 8 4))
  '((30 10 6 2)(30 10 6 4)(30 10 8 2)(30 10 8 4)(30 12 6 2)(30 12 6 4)(30 12 8 2)(30 12 8 4)) 
  '((29 10 6 2)(29 10 6 4)(29 10 8 2)(29 10 8 4)(29 12 6 2)(29 12 6 4)(29 12 8 2)(29 12 8 4))
  '((30 10 6 2)(30 10 6 4)(30 10 8 2)(30 10 8 4)(30 12 6 2)(30 12 6 4)(30 12 8 2)(30 12 8 4)) 
  '((29 10 6 2)(29 10 6 4)(29 10 8 2)(29 10 8 4)(29 12 6 2)(29 12 6 4)(29 12 8 2)(29 12 8 4))
  '((30 10 6 2)(30 10 6 4)(30 10 8 2)(30 10 8 4)(30 12 6 2)(30 12 6 4)(30 12 8 2)(30 12 8 4)) 
))
(test (polys-string lex-rational-xyz S)
	'"[(29*x^10*y^6*z^2)+(29*x^10*y^6*z^4)+(29*x^10*y^8*z^2)+(29*x^10*y^8*z^4)+(29*x^12*y^6*z^2)+(29*x^12*y^6*z^4)+(29*x^12*y^8*z^2)+(29*x^12*y^8*z^4),(30*x^10*y^6*z^2)+(30*x^10*y^6*z^4)+(30*x^10*y^8*z^2)+(30*x^10*y^8*z^4)+(30*x^12*y^6*z^2)+(30*x^12*y^6*z^4)+(30*x^12*y^8*z^2)+(30*x^12*y^8*z^4),(29*x^10*y^6*z^2)+(29*x^10*y^6*z^4)+(29*x^10*y^8*z^2)+(29*x^10*y^8*z^4)+(29*x^12*y^6*z^2)+(29*x^12*y^6*z^4)+(29*x^12*y^8*z^2)+(29*x^12*y^8*z^4),(30*x^10*y^6*z^2)+(30*x^10*y^6*z^4)+(30*x^10*y^8*z^2)+(30*x^10*y^8*z^4)+(30*x^12*y^6*z^2)+(30*x^12*y^6*z^4)+(30*x^12*y^8*z^2)+(30*x^12*y^8*z^4),(29*x^10*y^6*z^2)+(29*x^10*y^6*z^4)+(29*x^10*y^8*z^2)+(29*x^10*y^8*z^4)+(29*x^12*y^6*z^2)+(29*x^12*y^6*z^4)+(29*x^12*y^8*z^2)+(29*x^12*y^8*z^4),(30*x^10*y^6*z^2)+(30*x^10*y^6*z^4)+(30*x^10*y^8*z^2)+(30*x^10*y^8*z^4)+(30*x^12*y^6*z^2)+(30*x^12*y^6*z^4)+(30*x^12*y^8*z^2)+(30*x^12*y^8*z^4)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(x^12*y^8*z^4)+(x^12*y^8*z^2)+(x^12*y^6*z^4)+(x^12*y^6*z^2)+(x^10*y^8*z^4)+(x^10*y^8*z^2)+(x^10*y^6*z^4)+(x^10*y^6*z^2)]"
)




(set! S (list '((4 2 0 1) (-7 0 2 0)) '((1 1 1 2)  (3 1 0 4)) ) )
(test (polys-string lex-rational-xyz S)
	'"[(4*x^2*z)+(-7*y^2),(x*y*z^2)+(3*x*z^4)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(y^3*z)+(3*y^2*z^3),(y^5)+(27*y^2*z^6),(x*y*z^2)+(3*x*z^4),(x^2*z)+(-7/4*y^2)]"
)




(set! S (list '((1 2 0 1)(-1 0 2 0)) 
                '((1 0 1 2)(1 0 0 1)) 
                '((1 0 1 0)(-1 0 0 1)) ))
(test (polys-string lex-rational-xyz S)
	'"[(x^2*z)+(-1*y^2),(y*z^2)+(z),(y)+(-1*z)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(z^3)+(z),(y)+(-1*z),(x^2*z)+(-1*z^2)]"
)




(set! S (list '((1 2 0 0)(1 0 2 0)(1 0 0 2)(-1 0 0 0)) 
                '((1 2 0 0)(1 0 2 0)(1 0 0 2)(-2 1 0 0)) 
                '((2 1 0 0)(-3 0 1 0)(-1 0 0 1))         ))
(test (polys-string lex-rational-xyz S)
	'"[(x^2)+(y^2)+(z^2)+(-1),(x^2)+(y^2)+(z^2)+(-2*x),(2*x)+(-3*y)+(-1*z)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))  
(test (polys-string lex-rational-xyz GB)
	'"[(z^2)+(-1/5*z)+(-23/40),(y)+(1/3*z)+(-1/3),(x)+(-1/2)]"
)




(set! S (list '((1 2 0 0)(1 0 0 2)(1 0 2 0)(-1 0 0 0))
                '((1 2 0 0)(1 0 0 2)(1 0 2 0)(-2 1 0 0))
                '((2 1 0 0)(-3 0 0 1)(-1 0 1 0))         ))
(test (polys-string lex-rational-xyz S)
	'"[(x^2)+(z^2)+(y^2)+(-1),(x^2)+(z^2)+(y^2)+(-2*x),(2*x)+(-3*z)+(-1*y)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(z^2)+(-3/5*z)+(1/40),(y)+(3*z)+(-1),(x)+(-1/2)]"
)




;; http://www.orcca.on.ca/~raqeeb/Publications/grobner_examples.html
(set! S (list '((1 0 1 2)(1 0 0 0)) '((1 2 0 0)(-1 0 0 2)) '((1 1 2 0)(1 0 0 0)) ))
(test (polys-string lex-rational-xyz S)
	'"[(y*z^2)+(1),(x^2)+(-1*z^2),(x*y^2)+(1)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(z^6)+(-1),(y)+(z^4),(x)+(z^4)]"
)





(set! S (list '((1 2 0)(2 1 2)) '((1 1 1)(2 0 3)(-1 0 0)) ))
(test (polys-string lex-rational-xyz S)
	'"[(x^2)+(2*x*y^2),(x*y)+(2*y^3)+(-1)]"
)
(set!  G (buchberger lex-rational-xyz S))
(set! RG (g-reduce lex-rational-xyz G))
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz  G)) (error "bug?"))
(if (not (grobner? lex-rational-xyz RG)) (error "bug?"))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(y^3)+(-1/2),(x)]"
)





(set! S (list '((1 2 0 0 0)(1 0 2 0 0)(1 0 0 2 0)(1 0 0 0 2))
                '((1 2 0 0 0)(2 0 2 0 0)(-1 0 1 1 0)(-1 0 0 0 2))
                '((1 1 0 0 0)(1 0 0 3 0)(-1 0 0 0 3))             ))
(test (polys-string (lex-rational '("t" "x" "y" "z")) S)
	'"[(t^2)+(x^2)+(y^2)+(z^2),(t^2)+(2*x^2)+(-1*x*y)+(-1*z^2),(t)+(y^3)+(-1*z^3)]"
)
(set!  G (buchberger (lex-rational '("t" "x" "y" "z")) S))
(set! RG (g-reduce (lex-rational '("t" "x" "y" "z")) G))
(set! GB (gbasis (lex-rational '("t" "x" "y" "z")) S))
(if (not (grobner? (lex-rational '("t" "x" "y" "z"))  G)) (error "bug?"))
(if (not (grobner? (lex-rational '("t" "x" "y" "z")) RG)) (error "bug?"))
(if (not (grobner? (lex-rational '("t" "x" "y" "z")) GB)) (error "bug?"))
(test (polys-string (lex-rational '("t" "x" "y" "z")) GB)
	'"[(y^12)+(-4*y^9*z^3)+(5*y^8)+(6*y^6*z^6)+(6*y^6*z^2)+(-10*y^5*z^3)+(5*y^4)+(-4*y^3*z^9)+(-12*y^3*z^5)+(5*y^2*z^6)+(13*y^2*z^2)+(z^12)+(6*z^8)+(9*z^4),(x*z^6)+(3*x*z^2)+(-1*y^11)+(4*y^8*z^3)+(-5*y^7)+(-5*y^5*z^6)+(-3*y^5*z^2)+(10*y^4*z^3)+(-5*y^3)+(2*y^2*z^9)+(6*y^2*z^5)+(-3*y*z^6)+(-7*y*z^2),(x*y)+(y^6)+(-2*y^3*z^3)+(2*y^2)+(z^6)+(3*z^2),(x^2)+(y^6)+(-2*y^3*z^3)+(y^2)+(z^6)+(z^2),(t)+(y^3)+(-1*z^3)]"
)




(set! S '( ((1 1 0 0)(1 0 1 0)(1 0 0 1)(-6 0 0 0))
             ((1 2 0 0)(1 0 2 0)(1 0 0 2)(-14 0 0 0))
             ((1 3 0 0)(1 0 3 0)(1 0 0 3)(-36 0 0 0))
))
(test (polys-string lex-rational-xyz S)
	'"[(x)+(y)+(z)+(-6),(x^2)+(y^2)+(z^2)+(-14),(x^3)+(y^3)+(z^3)+(-36)]"
)
(set! GB (gbasis lex-rational-xyz S))
(if (not (grobner? lex-rational-xyz GB)) (error "bug?"))
(test (polys-string lex-rational-xyz GB)
	'"[(z^3)+(-6*z^2)+(11*z)+(-6),(y^2)+(y*z)+(-6*y)+(z^2)+(-6*z)+(11),(x)+(y)+(z)+(-6)]"
)
